UNIT DPMI;
{$r-,q-,i-,x+,opt+,d-,l-}
{
Unit for DPMI-interface.      
version 0.4 by JacmeT (jacmet@iname.com) 
started      : 14-06-98 16:55 
last modified: 15-02-99 01:00
}

INTERFACE

TYPE RealmodeRegisterType = record
                              _EDI: dword;
                              _ESI: dword;
                              _EBP: dword;
                              RES1: dword;
                              _EBX: dword;                              
                              _EDX: dword;
                              _ECX: dword; 
                              _EAX: dword;
                              FLAGS: word;
                              _ES  : word;
                              _DS  : word;
                              _FS  : word;
                              _GS  : word;
                              _IP  : word;
                              _CS  : word;
                              _SP  : word;
                              _SS  : word;                  
                            end;  

VAR  RealmodeRegisters: RealmodeRegisterType; {for function SimulateRealmodeInterrupt}
     RealmodeSelector: dword;  {for function AllocateRealmodeMemory}

{==============================================================================================}
Function SimulateRealmodeInterrupt(InterruptNumber: byte): boolean;
Function AllocateRealmodeMemory(NumberOfParagrams: dword): pointer; 
Function DeAllocateRealmodeMemory: boolean;
Function MapPhysicalMemory(PhysicalAddress: pointer; size: dword): pointer;
Function FreeMemoryMapping(LinearAddress: pointer): boolean;
{==============================================================================================}

IMPLEMENTATION
{==============================================================================================}
Function SimulateRealmodeInterrupt(InterruptNumber: byte): boolean; assembler;
 asm
  mov eax, 0300h       {DPMI.SimulateRealmodeInterruptcall}
  mov bl,[InterruptNumber]
  xor ecx,ecx          {don't copy parameters from stack}
  mov edi,offset RealmodeRegisters
  int 31h 
  
  jc @error            {was it succesfull?}
  mov al,1
  jmp @end
 @error:
  xor eax,eax
 @end: 
end;
{==============================================================================================}
{Allocates Realmode memory. returns zero if error, address of block if no error occured.}
Function AllocateRealmodeMemory(NumberOfParagrams: dword): pointer; assembler;
 asm
  mov eax, 0100h              {DPMI.AllocateRealmodeMemory}
  mov ebx,[NumberOfParagrams] {1 paragram = 16 bytes}
  int 31h

  jc @error
  mov [RealmodeSelector],edx  {save selector for deallocation}
  shl eax,4
  jmp @end
 @error:
  xor eax,eax
 @end: 
 end;
{==============================================================================================}
{Deallocates Realmode memory allocated by AllocateRealmodeMemory}
Function DeAllocateRealmodeMemory: boolean; assembler;
 asm
  mov eax, 0101h              {DPMI.DeAllocateRealmodeMemory}
  mov edx,[RealmodeSelector]
  int 31h

  jc @error                   {was it succesfull?}
  mov al,1
  jmp @end
 @error:
  xor eax,eax
 @end:
 end; 
{==============================================================================================}
Function MapPhysicalMemory(PhysicalAddress: pointer; size: dword): pointer; assembler;
 asm
  mov eax, 0800h
  mov ecx,[PhysicalAddress]
  mov ebx,ecx
  and ecx,0FFFFh
  shr ebx,16
  {now bx:cx = PhysicalAddress}
  mov edi,[Size]
  mov esi,edi
  and edi,0FFFFh
  shr esi,16
  {now si:di = Size}
  int 31h
  jnc @end                    {was it succesfull?}
  xor ebx,ebx
  xor ecx,ecx
  {else bx:cx = 0}
 @end:
  shl ebx,16
  and ecx,0FFFFh
  mov eax,ebx
  add eax,ecx
  {now eax = bx:cx}  
 end;
{==============================================================================================}
Function FreeMemoryMapping(LinearAddress: pointer): boolean; assembler;
 asm
  mov eax, 0801h
  mov ecx,[LinearAddress]
  mov ebx,ecx
  and ecx,0FFFFh
  shr ebx,16
  {now bx:cx = LinearAddress}
  int 31h
  jnc @end                    {was it succesfull?}
  xor eax,eax
 @end:
 end;
{==============================================================================================}

begin
end.
{==============================================================================================}