program makeinc;
{
This is the MakeInc program.
-----------------------------------------
Current Version:
         0.03 - 02-02-99 by JacmeT (jacmet@iname.com)

Purpose: 
        To create include files for a system
        (mainly GFX-SYSTEM. If a includefile
        of the same name already exists with
        the same includes, the file is _NOT_
        overwritten. This way it will not 
        cause an unnecessary recompile of the
        unit by the make utility.
}
uses tool;

const VERSION = '0.03';
      AUTHOR  = 'Peter Korsgaard ''99';
      SIZE    = 80;

var f: text;
    c: longint;
    counter: array[0..255] of byte;
    Found: boolean;
    temp: string;

begin
 if paramcount=0 then
  begin
   writeln('MakeInc version ',VERSION,' by ',AUTHOR);
   writeln('Syntax is:');
   writeln('MAKEINC NAME_OF_OUTPUT DEFINE_1 DEFINE_2 .. DEFINE_N');
   writeln('eks: MAKEINC GFX.INC DEBUG VESA');
   writeln('This generates the GFX.INC file which contains {$DEFINE DEBUG} {$DEFINE VESA}');
  end
 else
  begin
   assign(f,paramstr(1));
   if FileExist(paramstr(1)) then
    begin
     {if the file exists then check if the
     parameters are the same. If not, then create the file again}
     for c:=0 to 255 do counter[c]:=0;
     reset(f);
     repeat
      readln(f,temp);     
      {does the string contain a $DEFINE tag?}
      Found:=true;
      if ((pos('{$DEFINE ',temp)>0) and (pos('}',temp)-pos('{$DEFINE ',temp)-10>0)) then
       begin
        temp:=copy(temp,pos('{$DEFINE ',temp)+9,pos('}',temp)-pos('{$DEFINE ',temp)-10);
        c:=2;
        Found:=false;
        while ((c<=paramcount) and (Found=false)) do
         begin
          if temp=paramstr(c) then 
           begin
            counter[c]:=1;
            Found:=true;
           end;
          c:=c+1;
         end;
       end;  
     until ((eof(f)) or (found=false));
     close(f);
     {if found=true, then all defines in file also in param}
     if (found=true) then
      begin
       c:=2;
       while ((c<paramcount) and (counter[c]>0)) do begin c:=c+1; end;       
       if counter[c]>0 then halt;
      end;  
    end;
   rewrite(f);
   writeln(f,'{created by MakeInc version ',VERSION,' by ',AUTHOR,'}');
   if paramcount>1 then 
    begin
     for c:=2 to paramcount do writeln(f,'{$DEFINE ',paramstr(c),' }');
    end;
   close(f);
  end; 
end.
